<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// | Theme switch plugin                                                   |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008      Pavel Budka                http://pbudka.co.cc |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+
if (!defined('THEME_SWITCH_PATH'))
define('THEME_SWITCH_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');
class theme_controler {
static public function _switch()
{
  global $user, $template, $conf, $lang;
  if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }
  $same = $user['template'].'/'.$user['theme'];
  if ( isset( $_GET['theme']) and isset( $_GET['template']) )
  {
    if ( !empty($_GET['theme']) and !empty($_GET['template']) and
      file_exists( PHPWG_ROOT_PATH.'template/'.$_GET['template'].'/theme/'.$_GET['theme']) )
    {
      if (is_a_guest() or is_generic())
      {
        setcookie( 'pwg_theme_switch', $_GET['theme'],
          time()+60*60*24*30, cookie_path() );
        setcookie( 'pwg_template_switch', $_GET['template'],
          time()+60*60*24*30, cookie_path() );
      }
      else
      {
        $query = 'UPDATE '.USER_INFOS_TABLE.'
        SET template = \''.$_GET['template'].'/'.$_GET['theme'].'\'
        WHERE user_id = '.$user['id'].'
        ;';
        pwg_query($query);
      }
      $user['theme'] = $_GET['theme'];
      $user['template'] = $_GET['template'];
    }
  }
  else
  // Users have $user['template']/$user['theme'] 
  // Guest or generic members will use their cookied $user['template']/$user['theme'] !
  if ((is_a_guest() or is_generic())
    and isset( $_COOKIE['pwg_theme_switch'] )
    and isset( $_COOKIE['pwg_template_switch'] ) )
  {
    $user['template'] = $_COOKIE['pwg_template_switch'];
    $user['theme'] = $_COOKIE['pwg_theme_switch'];
  }
}

static public function _flags()
// Lets user choose from icons 
// Only themes which have gif icon provided in icons plugin directory will be provided to users.
// Gif file name must be the same as theme's name and must be stored in sub directory named according to template's name.  
{
  global $user, $template, $lang;
  
  $available_theme = get_pwg_themes();

  $url_starting = get_query_string_diff(array('template', 'theme'));

  foreach ( $available_theme as $code ) {
    $qlc_img =  'plugins/theme_switch/icons/' . $code . '.gif';
         
    if (file_exists(PHPWG_ROOT_PATH.$qlc_img)) {
      list($temp, $theme) = split('/',$code);
      $qlc_url = str_replace(array('=&amp;','?&amp;'),array('&amp;','?'),
                 add_url_params( $url_starting, array( 'template' => $temp, 'theme' => $theme  ) ));
      if (isset($lang['theme']))
        $qlc_alt = $lang['theme'].': '.ucwords( $code );
      else
        $qlc_alt = ucwords( $code );
      $qlc_title =  $qlc_alt;
      $qlc = array ( 
        'url' => $qlc_url,
        'alt' => $qlc_alt,
        'img' => $qlc_img,
        );
      if ( $code !== $user['template'].'/'.$user['theme'])
        $lsw['flags'][$code] = $qlc ;
      else $lsw['Active'] = $qlc;
      }
  }
    
  $template->set_filename('theme_flags', dirname(__FILE__) . '/flags.tpl');
  $lsw['side'] = ceil(sqrt(count($available_theme)));
  $template->assign(array(
    'theme_switch'=> $lsw,
    'THEME_SWITCH_PATH' => THEME_SWITCH_PATH,
  ));
  $flags = $template->parse('theme_flags',true);
  $template->clear_assign('theme_switch');
  $template->concat( 'PLUGIN_INDEX_ACTIONS', $flags);
}

static public function _select()
// Lets user choose using select control 
// All available themes will be provided to users. 
{
  global $user, $template, $lang;
  
  $available_theme = get_pwg_themes();
  $url_starting = get_query_string_diff(array('lang'));
  $options='<li><span class="property">
   <label for="template">'.$lang['theme'].'</label>
  </span>
  <select name="template" onchange="javasript:window.location=this.value">';
  foreach ( $available_theme as $code )
  {
    list($temp, $theme) = split('/',$code);
    $qlc_url = str_replace(array('=&amp;','?&amp;'),array('&amp;','?'),
      add_url_params( $url_starting, array( 'template' => $temp, 'theme' => $theme  ) ));
    
    if ( $code == $user['template'].'/'.$user['theme'] )
      $tmp='" selected="selected">';
    else
      $tmp='">';
    $options=$options.'
    <option label="'.$code.'" value="'.$qlc_url.$tmp.$code.'</option>';
  }
  $options=$options.'
  </select></li>';
  $template->concat( 'PLUGIN_INDEX_ACTIONS',$options);
}
}
  /* {html_head} usage function */
  /* See flags.tpl for example (due no catenation available) */
if (!function_exists('Componant_exists')) {
  function Componant_exists($path, $file)
    { return file_exists( $path . $file); }
}
?>
